<?php
/*
Mage Reviews
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

/* Basic plugin definitions */
/*
 * @level 		Casting
 * @author		Mage Cast 
 * @url			http://magecast.com
 * @license   	http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */
?>
<?php
if (!defined('MAGECAST_REVIEWS')) exit;
add_action('init', 'summon_magecast_reviews');
add_filter('mage_options_dashboard','mage_reviews_dashboard_update');
function mage_reviews_dashboard_update($options){
	$options[] = array(
		'name' => __('Mage Reviews','mage-reviews'),
		'link' => get_admin_url(null, 'admin.php?page=mage_reviews'),
		'desc' => '<p><strong>'.__('Current Version','mage-reviews').':</strong> '.MAGECAST_REVIEWS_VER.'</p>
						<p><strong>'.__('Features in Future Updates:','mage-reviews').'</strong></p>
						<ul>
						<li><span class="glyphicon glyphicon-time"></span> '.__('Additional BuddyPress & Member Features','mage-reviews').'</li>
						<li><span class="glyphicon glyphicon-time"></span> '.__('Mutli Criteria Rating Options','mage-reviews').'</li>
						<li><span class="glyphicon glyphicon-time"></span> '.__('Custom Review Form Design & Display','mage-reviews').'</li>
						<li><span class="glyphicon glyphicon-time"></span> '.__('Comment Rating Admin Features','mage-reviews').'</li>
						<li><span class="glyphicon glyphicon-time"></span> '.__('and Much More','mage-reviews').'</li>
						</ul>',
		'type' => 'legend');
	return $options;
}

function summon_magecast_reviews(){	
	if (current_user_can('switch_themes')) {
		add_action('admin_init', 'mage_reviews_init' );	
		add_action('admin_menu', 'summon_magecast_reviews_dashboard');				
	}
}
function summon_magecast_reviews_dashboard(){
	global $themename, $shortname, $submenu, $menu;
	$mage_options_page = add_submenu_page('mage_cast','Mage Reviews','Reviews','manage_options','mage_reviews','mage_reviews_page');	
	add_action('admin_print_scripts-'.$mage_options_page, 'mage_load_scripts');			
	add_action('admin_print_styles-'.$mage_options_page, 'mage_load_styles' );	
}
function mage_reviews_init() {			
	global $pagenow;	
	if('media-upload.php' == $pagenow || 'async-upload.php' == $pagenow )add_filter( 'gettext', 'replace_mage_upload_text',1,3);
	add_filter( 'mage_sanitize_text', 'sanitize_text_field' );
	add_filter( 'mage_sanitize_select', 'mage_sanitize_enum', 10, 2);
	add_filter( 'mage_sanitize_radio', 'mage_sanitize_enum', 10, 2);
	add_filter( 'mage_sanitize_legend', 'mage_sanitize_enum', 10, 2);
	add_filter( 'mage_sanitize_images', 'mage_sanitize_enum', 10, 2);
	add_filter( 'mage_sanitize_checkbox', 'mage_sanitize_checkbox' );
	add_filter( 'mage_sanitize_multicheck', 'mage_sanitize_multicheck', 10, 2 );
	add_filter( 'mage_sanitize_upload', 'mage_sanitize_upload' );
	$mage_settings = get_option('mage_reviews');
	$id = 'mage_ratings';
	if (isset($mage_settings['id'])){
		if ($mage_settings['id'] !== $id) { 
			$mage_settings['id'] = $id;
			update_option('mage_reviews',$mage_settings);		
		}
	} else { 
		$mage_settings['id'] = $id;
		update_option('mage_reviews',$mage_settings);
	}
	if (get_option($mage_settings['id']) === false) mage_setdefaults('reviews');
	register_setting('mage_reviews',$mage_settings['id'],'mage_reviews_validate' );
}
function mage_reviews_page() {
	global $craft;
?>
<div id="mage-wrap">
<?php settings_errors(); ?>
<div id="container" class="row">  
    <form id="mage-form" method="post" class="form-horizontal" action="options.php">
		<?php settings_fields('mage_reviews'); ?>
		<div id="magecast-content" class="magecast-content tab-content"><?php fields(mage_reviews_options(),'reviews'); ?></div>
	<!-- Footer Navbar and Submit -->         
		<div class="navbar navbar-static-bottom">
            	<input type="submit" class="btn btn-brown" name="update" id="update" value="<?php esc_attr_e( 'Save Options', 'mage-reviews' ); ?>" />        	
 		</div>
    </form>
</div>
</div><?php
}
function mage_reviews_validate($input) {
	global $craft;
	if (!current_user_can('manage_options'))die('Insufficient Permissions');
	$clean = array();
	$options = mage_reviews_options();	
	foreach ($options as $option ){
		if (!isset($option['id']))continue;
		if (!isset($option['type']))continue;
		$id = cog($option['id']);
		if (!isset($input[$id])) {
			if (in_array($option['type'], array('text','textarea','select','radio','color','upload')))$input[$id] = isset($option['std'])? $option['std']:'';		
			if ('checkbox' == $option['type'])$input[$id] = false;				
			if ('multicheck' == $option['type'])$input[$id] = array();					
		}
		if (has_filter('mage_sanitize_' .$option['type'])){				
			$clean[$id] = apply_filters('mage_sanitize_' . $option['type'], $input[$id], $option);	
		} 
	}
	add_settings_error('mage_reviews','save_options', __( 'Options Saved', 'mage-reviews' ), 'updated modal fade in' );
	return $clean;
} 
function mage_reviews_options(){
	$options = array();				
	$options[] = array('name' => 'Ratings','icon' => 'star','type' => 'heading');		
	$options[] = array('name' => __('Settings','mage-reviews'),'parent' => 'ratings','type' => 'subheading');	
	$options[] = array(
		'name' => __('Attach to Post Types','mage-reviews'),
		'desc' => __('Choose the post types with the comment form to add the rating option to.','mage-reviews'),
		'id' => 'post_type_ratings',		
		'type' => 'multicheck',
		'options'=>mage_post_type_options());
	$options[] = array(
		'name' => __('Rating Average','mage-reviews'),
		'desc' => __('Choose to display the Rating average above or below the post, or to keep it hidden.','mage-reviews'),
		'id' => 'display_average',		
		'type' => 'radio',
		'options'=>array('0'=>__('Hidden','mage-reviews'),'1'=>__('Top','mage-reviews'),'2'=>__('Bottom','mage-reviews')),
		'std' => '0');
	$options[] = array(
		'name' => __('Author Rating','mage-reviews'),
		'desc' => __('Display an Authors Rating above or below comment text, or not at all.','mage-reviews'),
		'id' => 'display_author_rating',		
		'type' => 'radio',
		'options'=>array('0'=>__('Hidden','mage-reviews'),'1'=>__('Above Comment','mage-reviews'),'2'=>__('Below Comment','mage-reviews')),
		'std' => '1');
	$options[] = array(
		'name' => __('Empty Average Bar','mage-reviews'),
		'desc' => __('Choose to show rating average even if empty.','mage-reviews'),
		'id' => 'display_average_empty',		
		'type' => 'checkbox',
		'std' => '0');		
	$options[] = array(
		'name' => __('Require Rating','mage-reviews'),
		'desc' => __('Require a rating before a comment can be submitted.','mage-reviews'),
		'id' => 'optional_review',		
		'type' => 'checkbox',
		'std' => '1');
	$options[] = array(
		'name' => __('Strict Reviews','mage-reviews'),
		'desc' => __('Restrict each User to only 1 review submission per page.','mage-reviews'),
		'id' => 'strict_user_reviews',		
		'type' => 'checkbox',
		'std' => '1');
	$options[] = array(
		'name' => __('Maximum Rating','mage-reviews'),
		'desc' => __('Choose the maximum rating that a user can rate content with.','mage-reviews'),
		'id' => 'rate_count',
		'std' => '5',		
		'type' => 'select',
		'options'=>array('2'=>'2','3'=>'3','4'=>'4','5'=>'5','6'=>'6','7'=>'7','8'=>'8','9'=>'9','10'=>'10'));	
	$options[] = array(
		'name' => __('Rating Icon','mage-reviews'),
		'desc' => __('The icon for each rating block before a user choose a rating.','mage-reviews'),
		'id' => 'rating_icon',
		'std' => MAGECAST_REVIEWS_URL.'img/star-0.png',
		'type' => 'upload');
	$options[] = array(
		'name' => __('Rating Icon Hover','mage-reviews'),
		'desc' => __('The icon that displays when a user hovers or chooses a rating.','mage-reviews'),
		'id' => 'rating_icon_hover',
		'std' => MAGECAST_REVIEWS_URL.'img/star-1.png',
		'type' => 'upload');	
	$options[] = array('name' => __('Help','mage-reviews'),'parent' => 'ratings','type' => 'subheading');	
	$options[] = array(
		'name' => __('Installation','mage-reviews'),
		'desc' => __('<p>Upon activation, simply select the post types you want to display the rating option on under <code>Settings</code>-><code>Attach To Post Types</code>.</p><p>Rating fields are added to the comment form, that has to already be in place on the post types chosen. To verify this, make sure the template tag <code>comment_form();</code> is placed in corresponding template files of your theme.</p>','mage-reviews'),
		'type' => 'legend');
	$options[] = array(
		'name' => __('Displaying Review Average','mage-reviews'),
		'desc' => '<p>'.__('You can display the rating average by using either of the methods below:','mage-reviews').'</p><ul>
		<li>'.__('<strong>Shortcode:</strong> Display average reviews on chosen post types by adding [reviews] to your post content at a desired location.','mage-reviews').'</li>
		<li>'.__('<strong>Auto-Display:</strong> Activate this option in <code>Settings</code>-><code>Rating Average</code>.','mage-reviews').'</li>
		<li>'.__('<strong>Template Tag:</strong> Add <?php echo mage_get_review_average(); ?> in desired template file.','mage-reviews').'</li></ul>',
		'type' => 'legend');
		
	$options[] = array(
		'name' => __('Restricting User Review Count','mage-reviews'),
		'desc' => __('<p>You can enable the restricting of 1 Comment per User at <code>Settings</code>-><code>Strict Reviews</code>.</p><p>This option does not remove the comment form, but instead displays the error message "You have already submitted a rating here".</p><p>To <strong>Remove Comment Form</strong> completely if the user has already rated, you can replace <code>comment_form();</code> with <code>if (!mage_user_reviewed()) { comment_form(); }</code>.</p>','mage-reviews'),
		'type' => 'legend');	
	$options[] = array(
		'name' => __('Shortcode [recent_reviews] Parameters','mage-reviews'),
		'desc' => '<table class="table">
          <thead>
            <tr>
              <th>'.__("Parameter", "magecast").'</th>
              <th>'.__("Type", "magecast").'</th>
			  <th>'.__("Description", "magecast").'</th>
              <th>'.__("Default", "magecast").'</th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td><code>count</code></td>
              <td><div class="label label-primary">int</div></td>
			  <td>'.__("The maximum amount of recent reviews to display.", "magecast").'</td>
              <td>3</td>
            </tr>
            <tr>
              <td><code>type</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__("The post type slug of the post type you want to feature reviews from.", "magecast").'</td>
              <td>"post"</td>
            </tr>
            <tr>
              <td><code>excerpt</code></td>
              <td><div class="label label-primary">int</div></td>
			  <td>'.__("The amount of characters you would like to display from the excerpt before appending <code>[...]</code>. Use <code>0</code> to disable excerpt.", "magecast").'</td>
              <td>50</td>
            </tr>
			<tr>
              <td><code>avatar</code></td>
              <td><div class="label label-primary">int</div></td>
			  <td>'.__('Size of the Author Avatar in <code>px</code>. Example: "avatar"=50 creates the avatar image in 50px width and 50px height. Use <code>0</code> to disable avatar.', "magecast").'</td>
              <td>50</td>
            </tr>
			<tr>
              <td><code>class</code></td>
              <td><div class="label label-success">string</div></td>
			  <td>'.__('Additional CSS classes to add to the wrapper.', "magecast").'</td>
              <td>'.__('empty', "magecast").'</td>
            </tr>			
          </tbody>
        </table><p><strong>'.__('Usage', "magecast").':</strong><br /><code>[recent_reviews type="page" count=5 excerpt=100 avatar=0]</code></p>',
		'type' => 'legend');	
	$wp_support = 'http://wordpress.org/support/plugin/mage-reviews';
	$mb_article = 'http://blog.maximusbusiness.com/2013/11/wordpress-review-rating-plugin/';
	$options[] = array(
		'name' => __('Support','mage-reviews'),
		'desc' => '<p>'.sprintf(__('Please refer to <a href="%s" target="_blank">this article</a> and to <a href="%s" target="_blank">WordPress Support Forums</a> if you need help, find any bugs, have suggestions or would like help us with a rating.','mage-reviews'),$mb_article,$wp_support).'</p>',
		'type' => 'legend');
	return $options;	
}