<?php
/*
Mage Reviews
*/
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
?>
<?php
if (!defined('MAGECAST_REVIEWS')) exit;
add_action('init', 'summon_mage_ratings');
add_action( 'comment_form_logged_in_after', 'mage_rating_fields' );
add_action( 'comment_form_after_fields', 'mage_rating_fields' );
add_action('comment_post', 'mage_add_comment_rating',9);
add_action('comment_post', 'mage_update_rating',9);
add_filter( 'preprocess_comment', 'mage_verify_comment_rating' );
add_action('edit_comment', 'mage_update_rating');	
add_action('comment_unapproved_to_approved', 'mage_update_rating');
add_action('comment_approved_to_unapproved', 'mage_update_rating');
add_action('comment_spam_to_approved', 'mage_update_rating');
add_action('comment_approved_to_spam', 'mage_update_rating');
add_action('comment_approved_to_trash', 'mage_update_rating');
add_action('comment_trash_to_approved', 'mage_update_rating');
add_filter('comment_text','mage_display_comment_rating',99);
add_action('add_meta_boxes_comment', 'mage_custom_comment_meta_box' );
add_shortcode('reviews', 'mage_reviews_average');
add_action( 'edit_comment', 'mage_extend_comment_edit_metafields' );
if (mage_get_option('reviews','display_average')) add_filter( 'the_content', 'mage_add_review_average'); 
add_shortcode( 'recent_reviews', 'mage_get_recent_reviews' );
add_action( 'widgets_init', 'mage_recent_reviews_widget' );
function mage_recent_reviews_widget() {
	register_widget('Mage_Recent_Reviews');
}
function mage_query_comments($count=0,$type='0',$post_id = 0, $user_id = 0){
	$args = array('status'=>'approve','post_status'=>'publish','meta_key' => '_mage_rating');	
	if($type != '0')$args['post_type'] = $type;
	if($count != 0)$args['number'] = $count;
	if ($user_id != 0) $args['user_id']  = $user_id;
	if ($post_id != 0) $args['post_id']  = $post_id;
	$comments = get_comments($args);
	if ($comments) return $comments;
	$args['meta_key'] = 'rating';
	$comments = get_comments($args);
	if ( $comments )foreach ((array) $comments as $comment)mage_update_comment_meta($comment->comment_ID);
	$args['meta_key'] = '_mage_rating';
	$comments = get_comments($args);
	return $comments;
}
function mage_update_comment_meta($comment_id){
	$old_rating = get_comment_meta ($comment_id, 'rating', true );
	if (!empty($old_rating)) {
		delete_comment_meta( $comment_id, 'rating');
		update_comment_meta( $comment_id, '_mage_rating',$old_rating );
	}	
}
function mage_update_post_average($post_id){
	$old_average = get_post_meta ($post_id, 'rating', true );
	if (!empty($old_average)) {
		delete_post_meta($post_id, 'rating');
		update_post_meta($post_id, '_mage_rating',$old_average);
	}	
}
class Mage_Recent_Reviews extends WP_Widget {
	function Mage_Recent_Reviews() {
		$widget_data = array('classname' => 'widget_recent_reviews mage_recent_reviews', 'description' => __( 'The most recent approved reviews.' ) );
		$this->WP_Widget('mage-recent-reviews', __('Mage Recent Reviews','mage-reviews'), $widget_data);
		$this->alt_option_name = 'widget_recent_reviews';
		add_action( 'comment_post', array(&$this, 'flush_widget_cache'));
		add_action( 'transition_comment_status', array(&$this, 'flush_widget_cache') );
	}	

	function flush_widget_cache() {
		wp_cache_delete('widget_recent_reviews', 'widget');
	}

	function widget( $args, $instance ) {
		global $comments, $comment;

		$cache = wp_cache_get('widget_recent_reviews', 'widget');
		if (!is_array($cache))$cache = array();
		if (!isset($args['widget_id']))$args['widget_id'] = $this->id;
		if (isset($cache[$args['widget_id']])) {
			echo $cache[$args['widget_id']];
			return;
		}
		extract($args, EXTR_SKIP);
 		$output = '';
		$title = isset( $instance['title']) ? $instance['title'] : __( 'Recent Reviews','mage-reviews');
		$title = apply_filters('widget_title', $title, $instance, $this->id_base );
		$excerpt = isset($instance['excerpt_length']) && !empty($instance['excerpt_length'])? absint( $instance['excerpt_length']) : 50;
		$avatar = isset($instance['avatar_size']) && !empty($instance['avatar_size'])? absint( $instance['avatar_size'] ) : 50;
		$number = isset( $instance['number']) && !empty($instance['number'])? absint( $instance['number'] ) : 5;
		$type = isset($instance['type'])? esc_attr($instance['type']) : '0';		
		$comments = mage_query_comments($number,$type);
		$output .= $before_widget;
		if ( $title )$output .= $before_title . $title . $after_title;
		$output .= '<ul class="recent-reviews" id="recent-reviews">';
		if ( $comments ) {
			$post_ids = array_unique(wp_list_pluck($comments,'comment_post_ID'));
			_prime_post_caches( $post_ids, strpos( get_option( 'permalink_structure' ), '%category%' ), false );
			foreach ((array) $comments as $comment) {
				$item = $avatar != 0 ? '<div class="review-thumbnail">'.get_avatar($comment, $avatar).'</div>' : '';
				$item .= '<div id="review-'.$comment->comment_ID .'" class="review-body">
				<div class="review-meta"><span itemprop="author">'.get_comment_author($comment->comment_ID).'</span> reviewed '.mage_comment_title($comment).mage_comment_date($comment).'</div>';
				$item .= mage_get_comment_rating($comment);
				if ($excerpt != 0) $item .= mage_comment_excerpt($comment,$excerpt);
				$item .= '</div>'; 
				$output .= '<li class="recent-review" itemprop="review" itemscope itemtype="http://schema.org/Review">'.$item.'</li>';
			}
 		}
		$output .= '</ul>';
		$output .= $after_widget;
		echo $output;
		$cache[$args['widget_id']] = $output;
		wp_cache_set('widget_recent_reviews', $cache, 'widget');				
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['type'] = strip_tags($new_instance['type']);
		$instance['excerpt_length'] = (int) $new_instance['excerpt_length'];
		$instance['number'] = (int) $new_instance['number'];
		$instance['avatar_size'] = (int) $new_instance['avatar_size'];		
		$this->flush_widget_cache();

		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_recent_reviews']) )delete_option('widget_recent_reviews');
		return $instance;
	}

	function form( $instance ) {
		$title = isset($instance['title']) ? esc_attr($instance['title']) : '';
		$type = isset($instance['type']) ? esc_attr($instance['type']) : 'any';
		$avatar = isset($instance['avatar_size']) ? absint($instance['avatar_size']) : 50;
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		$excerpt = isset($instance['excerpt_length']) ? absint($instance['excerpt_length']) : 50;
		$types = mage_post_type_options();
		$types = array('0'=>__('All','mage-reviews')) + $types;
?>
		<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title','mage-reviews'); ?>:</label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></p>
		<p><label for="<?php echo $this->get_field_id( 'type' ); ?>"><?php _e( 'Post Type','mage-reviews'); ?></label> 
        <select id="<?php echo $this->get_field_id( 'type' ); ?>" name="<?php echo $this->get_field_name( 'type' ); ?>" class="widefat" style="width:100%;">
        <?php foreach ($types  as $ptype => $type_name){ 
		?>
        <option value="<?php echo $ptype; ?>" <?php if ($ptype == $type) echo 'selected="selected"'; ?>><?php echo $type_name; ?></option>
        <? } ?>
		</select></p>
		<p><label for="<?php echo $this->get_field_id('number'); ?>"><?php _e('Reviews','mage-reviews'); ?>:</label>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
		
        <p><label for="<?php echo $this->get_field_id('excerpt_length'); ?>"><?php _e('Excerpt Length','mage-reviews'); ?>:</label>
		<input id="<?php echo $this->get_field_id('excerpt_length'); ?>" name="<?php echo $this->get_field_name('excerpt_length'); ?>" type="text" value="<?php echo $excerpt; ?>" size="3" /> <small><?php _e('Set to 0 to Disable Excerpt.','mage-reviews'); ?></small></p>
		
        <p><label for="<?php echo $this->get_field_id('avatar_size'); ?>"><?php _e('Avatar Size','mage-reviews'); ?>:</label>
		<input id="<?php echo $this->get_field_id('avatar_size'); ?>" name="<?php echo $this->get_field_name('avatar_size'); ?>" type="text" value="<?php echo $avatar; ?>" size="3" /> <small><?php _e('Set to 0 to Disable Avatar.','mage-reviews'); ?></small></p>
<?php
	}
}
function mage_get_recent_reviews( $atts, $content = null ){
	extract(shortcode_atts(array('count' => 3,'type'=>'post','excerpt'=>50,'avatar'=>50,'class'=>''), $atts));
	$class = magex($class,'class="recent-reviews ','" ', 'class="recent-reviews" ');
	global $post,$comment;
	$output = '';
	$comments = mage_query_comments($count,$type);
	if ($comments) {			
		$output = '<ul '.$class.' id="recent-reviews">';
		$post_ids = array_unique( wp_list_pluck( $comments, 'comment_post_ID' ) );
		_prime_post_caches( $post_ids, strpos( get_option( 'permalink_structure' ), '%category%' ), false );
		foreach ((array)$comments as $comment) {
			$item = $avatar != 0 ? '<div class="review-thumbnail">'.get_avatar($comment, $avatar).'</div>' : '';
			$item .= '<div id="review-'.$comment->comment_ID .'" class="review-body">
				<div class="review-meta"><span itemprop="author">'.get_comment_author($comment->comment_ID).'</span> reviewed '.mage_comment_title($comment).mage_comment_date($comment).'</div>';
			$item .= mage_get_comment_rating($comment);
			if ($excerpt != 0) $item .= mage_comment_excerpt($comment,$excerpt);
			$item .= '</div>'; 
			$output .= '<li class="recent-review" itemprop="review" itemscope itemtype="http://schema.org/Review">'.$item.'</li>';
		}
		$output .= '</ul>';			
 	}
	return $output;
}
function mage_comment_date($comment,$show_date = false){
	$date = get_comment_date('Y-d-m',$comment->comment_ID);
	$output = '<meta itemprop="datePublished" content="'.$date.'" />';
	return $show_date? $output.' on '.$date : $output;	
}
function mage_comment_title($comment){
	return '<a href="' . esc_url( get_comment_link($comment->comment_ID) ) . '" class="review-title">' . get_the_title($comment->comment_post_ID). '</a>';
}
function mage_comment_excerpt($comment,$count = 50){
	$comment_excerpt = trim( mb_substr( strip_tags( apply_filters( 'comment_text', $comment->comment_content )), 0, $count ));
	if(strlen($comment->comment_content)>$count)$comment_excerpt .= '[...]';	
	return  '<div class="review-summary" itemprop="description">'.$comment_excerpt.'</div>';
}
function mage_user_reviewed(){
	global $current_user,$post;
	$reviewed = false;
	$check = mage_count_reviews($post,$current_user->ID);
	if($check >= 1)$reviewed = true;
	return $reviewed;
}
function mage_count_reviews($post, $user_id=0){
	$comments = mage_query_comments($count=0,$type='0',$post->ID, $user_id);
	$count = 0;
	if ( $comments ) foreach ($comments as $comment) $count++;
	return $count;	
}
function mage_review_post_type($check){
	$post_type = get_post_type($check);
	if (!$post_type) return false;
	$types = mage_get_option('reviews','post_type_ratings');
	if (is_array($types) && in_array($post_type,$types)) {
  		return true;
	}
	return false;
}
function mage_add_review_average($content) {
	$val = mage_get_option('reviews','display_average','0');
	global $post;
	if (mage_review_post_type($post)) {
		if ($val != '0'){
  		$content = $val == '1'? mage_reviews_average() . $content : $content.mage_reviews_average();
		
		}
	}
	return $content;
}
function mage_reviews_average( $atts = array(), $content = null ){
	extract(shortcode_atts(array('status' => '','pre'=>'','wrap'=>'span','var'=>'review','one'=>'','zero'=>'','more'=>'','class'=>'','style'=>''), $atts));
	global $post;
	if (!is_object($post)) return '';
	$count = is_object($post)? mage_count_reviews($post): 0;
	mage_update_post_average($post->ID);
	if ($count == 0){
		$content = empty($zero)? $var.'s': $zero;
		$deleted = delete_post_meta($post->ID, '_mage_rating');
	} elseif ($count > 1) {
		$content = empty($more)? $var.'s': $more;	
	} else {
		$content = empty($one)? $var: $one;
	}
	$reviewCount = ' <div class="review-count">'.$pre.'<span itemprop="reviewCount">'.$count.'</span> '.$content.'</div>';
	$class=magex($class,'class="',' author-rating" ','class="author-rating" ');
	$style=magex($style,'style="','" ');
	$ave = $value = get_post_meta($post->ID, '_mage_rating', true);
	$maximum = mage_get_option('reviews','rate_count',5);
	$divident = 100/$maximum;
	if(!empty($ave)) {
		$value = round($value/$divident,2);
  		return '<div class="average-rating" itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating">
		<meta itemprop="ratingValue" content="'.$value.'"><div '.$class.$style.'><span style="width:'.$ave.'%;"></span></div>'.$reviewCount.'</div>';
	} else { 
		if (mage_get_option('reviews','display_average_empty')) return '<div '.$class.$style.' itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating"></div>'; 
	}
}
function mage_custom_comment_meta_box() {
    add_meta_box( 'title', __( 'Comment Rating','mage-reviews'), 'mage_comment_meta_boxes', 'comment', 'normal', 'high' );
}

function mage_comment_meta_boxes ( $comment ) {
	mage_update_comment_meta($comment->comment_ID);
	$rating = get_comment_meta( $comment->comment_ID, '_mage_rating', true );
	$count = mage_get_option('reviews','rate_count',5);
    wp_nonce_field( 'extend_comment_update', 'extend_comment_update', false );
    ?>
    <p>
        <label for="rating"><?php _e( 'Rating','mage-reviews'); ?>:</label>
			<span class="commentratingbox">
			<?php for( $i=1; $i <= $count; $i++ ) {
				echo '<span class="commentrating"><input type="radio" name="rating" id="rating" value="'. $i .'"';
				if ( $rating == $i ) echo ' checked="checked"';
				echo ' />'. $i .' </span>';
				}
			?>
			</span>
    </p>
    <?php
}
function mage_extend_comment_edit_metafields( $comment_id ) {
    if( ! isset( $_POST['extend_comment_update'] ) || ! wp_verify_nonce( $_POST['extend_comment_update'], 'extend_comment_update' ) ) return;
	mage_update_comment_meta($comment_id);
	if ( ( isset( $_POST['rating'] ) ) && ( $_POST['rating'] != '') ):
		$rating = wp_filter_nohtml_kses($_POST['rating']);
		update_comment_meta( $comment_id, '_mage_rating', $rating );
	else :
		delete_comment_meta( $comment_id, '_mage_rating');
	endif;

}
function mage_display_comment_rating($text){
	$val = mage_get_option('reviews','display_author_rating','1');
	global $comment;
	if (!is_object($comment)) return $text;
	$parent = $comment->comment_post_ID;
	if (mage_review_post_type($parent)) {
		if ($val != '0'){
			$text = $val == '1'? mage_get_comment_rating($comment).$text : $text.mage_get_comment_rating($comment);
		}
	}
	return $text;
}
function mage_get_comment_rating($comment){
	$count = mage_get_option('reviews','rate_count',5);
	mage_update_comment_meta($comment->comment_ID);
	if($rating = get_comment_meta ($comment->comment_ID, '_mage_rating', true )) {
		$percent = 100/$count*$rating;
		$commentrating = '<div class="author-rating" itemprop="reviewRating" itemscope itemtype="http://schema.org/Rating"><span style="width:'.$percent.'%;"></span>
		<meta itemprop="worstRating" content = "1" />
      <meta itemprop="ratingValue" content="'.$rating.'" />
      <meta itemprop="bestRating" content="'.$count.'" /></div>';
		return $commentrating;
	}
	return '';
}
function summon_mage_ratings(){	
	add_action( 'wp_enqueue_scripts', 'add_mage_ratings_scripts');
	add_action('wp_enqueue_scripts','add_mage_ratings_styles',20);
	add_action('wp_enqueue_scripts', 'mage_rating_custom_icon', 21 );
}
function add_mage_ratings_scripts() {
	global $post;
	if (mage_review_post_type($post)) {
		wp_enqueue_script('mage-ratings', MAGECAST_REVIEWS_SOURCE.'js/mage-ratings.js','','1.0',$in_footer = true);
		wp_enqueue_script('mage-ratings-ff', MAGECAST_REVIEWS_SOURCE.'js/mage-ratings-ff.js','','1.0',$in_footer = true);
	}
}
function add_mage_ratings_styles() {
	global $post;
	if (mage_review_post_type($post)) {
		wp_enqueue_style('mage-reviews', MAGECAST_REVIEWS_SOURCE.'css/mage-ratings.css');
	}
}
function mage_rating_fields() {
	global $post;
	$settings = mage_get_option('reviews','rating_icon');
	$count = mage_get_option('reviews','rate_count',5);
	if (mage_review_post_type($post)) {
		$icon = is_array($settings)? $settings['src'] : $settings;
		$req = mage_get_option('reviews','optional_review',true);	
		echo '<p class="comment-form-rating"><label for="rating">'.__('Rating','mage-reviews').( $req ? ' <span class="required">*</span>' : '' ).'</label>';
		echo '<span class="btn-group rating-options" data-toggle="buttons">';
		for( $i=$count; $i >= 1; $i-- ) echo '<label class="radio inline btn-rating btn" for="rating-'.$i.'"><input class="required" type="radio" name="rating" id="rating-'.$i.'" value="'. $i .'" /><img src="'.$icon.'" width="16" height="16" /></label>';
		echo '</span>';
		echo '</p>';
	}
}
function mage_rating_custom_icon() {
	global $post;
    $icon = mage_get_option('reviews','rating_icon');
	$count = mage_get_option('reviews','rate_count',5);
	if (mage_review_post_type($post)) {
		$width = $count*16;
		$icon_hover = mage_get_option('reviews','rating_icon_hover');
		$icon = isset($icon['src']) && !empty($icon['src'])? $icon['src'] : MAGECAST_REVIEWS_URL.'img/star-0.png';
		$icon_hover = isset($icon_hover['src']) && !empty($icon_hover['src'])? $icon_hover['src'] : MAGECAST_REVIEWS_URL.'img/star-1.png';
   		$custom_icon = '
        .author-rating {background-image: url('.$icon.');width: '.$width.'px;}
		.author-rating > span, .rating-options > .btn-rating:hover:before, .rating-options > .btn-rating.active:before, .rating-options > .btn-rating:hover ~ .btn-rating:before, .rating-options > .btn-rating.active ~ .btn-rating:before {background-image: url('.$icon_hover.');}';
    	wp_add_inline_style( 'mage-reviews', $custom_icon );
	}
}


function mage_update_rating($comment) {	
	if ( !is_object( $comment ) ){
        $comment = get_comment($comment);
    }
	$parent = $comment->comment_post_ID;
	if (mage_review_post_type($parent)) {
		mage_update_comment_meta($comment->comment_ID);
		mage_update_post_average($parent);
		$rating = get_comment_meta ($comment->comment_ID, '_mage_rating', true );
		$count = mage_get_option('reviews','rate_count',5);
		if (!empty($rating)) {
    		if(is_email($comment->comment_author_email)) {		
				$rating =!empty($rating)? get_comment_meta ($comment->comment_ID, '_mage_rating', true ):'';
				$comments = get_approved_comments($parent);
		
				if (empty($comments)) {
					add_post_meta($parent, '_mage_rating', $rating, true);
				} else {		
					$i = $rating = 0;	    		
   					foreach($comments as $comment) {
						$rate = get_comment_meta ($comment->comment_ID, '_mage_rating', true );
						if  (!empty($rate)) {
							$rating += $rate;
							$i++;
						}
					}
					if ($rating != 0 && $i != 0) {
						$ave = $rating/$i;  
						$rating = 100/$count*$ave;
						update_post_meta($parent, '_mage_rating', $rating);    
					} else {
						delete_post_meta($parent, '_mage_rating');  
					}
		 		}
    		}
		}
	}
}
function mage_add_comment_rating($comment_id){
	$comment = get_comment($comment_id);
	$parent = $comment->comment_post_ID;
	if (mage_review_post_type($parent)) {
		if (isset($_POST['rating']) && !empty($_POST['rating'])){
			$rating = wp_filter_nohtml_kses($_POST['rating']);
			add_comment_meta($comment_id, '_mage_rating', $rating, true);
		}
	}
}
function mage_verify_comment_rating( $commentdata ) {
	$parent = $commentdata['comment_post_ID'];
	if (mage_review_post_type($parent)) {
		if (mage_get_option('reviews','optional_review',true)) if (!isset($_POST['rating']) || empty($_POST['rating'])) wp_die( __( 'Error: Please add your rating.'));  
		if (mage_get_option('reviews','strict_user_reviews',true)) if (mage_user_reviewed()) wp_die( __( 'Error: You have already submitted a rating here.'));    
	}
	return $commentdata;
}